/* Xist IP builder*/



`timescale 1 ns / 1 ps

module FIFO ( Data, WrClock, RdClock, WrEn, RdEn,  Reset, RPReset, 

    Q, Empty, Full, AlmostEmpty, AlmostFull);

    input wire [15:0] Data;

    input wire WrClock;

    input wire RdClock;

    input wire WrEn;

    input wire RdEn;

    

    input wire Reset;

    input wire RPReset;

    output wire [7:0] Q;

    output wire Empty;

    output wire Full;

    output wire AlmostEmpty;

    output wire AlmostFull;



    wire Empty_int;

    wire Full_int;

	

    supply1 ipgen_VCC;

    supply0 ipgen_GND;



	



    defparam FIFO.FULLPOINTER1 = "0b01111111110000" ;

    defparam FIFO.FULLPOINTER = "0b10000000000000" ;

    defparam FIFO.AFPOINTER1 = "0b01111111110000" ;

    defparam FIFO.AFPOINTER = "0b10000000000000" ;

    defparam FIFO.AEPOINTER1 = "0b00000001011000" ;

    defparam FIFO.AEPOINTER = "0b00000001010000" ;

    defparam FIFO.ASYNC_RESET_RELEASE = "SYNC" ;

    defparam FIFO.GSR = "DISABLED" ;

    defparam FIFO.RESETMODE = "ASYNC" ;

    defparam FIFO.REGMODE = "NOREG" ;

    defparam FIFO.CSDECODE_R = "0b11" ;

    defparam FIFO.CSDECODE_W = "0b11" ;

    defparam FIFO.DATA_WIDTH_R = 9 ;

    defparam FIFO.DATA_WIDTH_W = 18 ;

    xsFIFO8KB FIFO  (.DI0(Data[0]), .DI1(Data[1]), .DI2(Data[2]), 

        .DI3(Data[3]), .DI4(Data[4]), .DI5(Data[5]), .DI6(Data[6]), 

        .DI7(Data[7]), .DI8(ipgen_GND), .DI9(Data[8]), .DI10(Data[9]), 

        .DI11(Data[10]), .DI12(Data[11]), .DI13(Data[12]), .DI14(Data[13]), 

        .DI15(Data[14]), .DI16(Data[15]), .DI17(ipgen_GND), .DI18(ipgen_GND),

		.DI19(ipgen_GND), .DI20(ipgen_GND), .DI21(ipgen_GND), .DI22(ipgen_GND),

		.DI23(ipgen_GND), .DI24(ipgen_GND), .DI25(ipgen_GND), .DI26(ipgen_GND),

		.DI27(ipgen_GND), .DI28(ipgen_GND), .DI29(ipgen_GND), .DI30(ipgen_GND),

		.DI31(ipgen_GND), .DI32(ipgen_GND), .DI33(ipgen_GND), .DI34(ipgen_GND),

		.DI35(ipgen_GND), .CSW0(ipgen_VCC), .CSW1(ipgen_VCC), .CSR0(ipgen_VCC),

		.CSR1(ipgen_VCC), .FULLI(Full_int), .EMPTYI(Empty_int), .WE(WrEn), .RE(RdEn),

		.ORE(RdEn),.CLKW(WrClock), .CLKR(RdClock), .RST(Reset), .RPRST(RPReset),

		.DO0(Q[0]), .DO1(Q[1]), .DO2(Q[2]), .DO3(Q[3]), .DO4(Q[4]), .DO5(Q[5]), .DO6(Q[6]), .DO7(Q[7]),

		.DO8(), .DO9(), .DO10(), .DO11(), .DO12(), .DO13(), .DO14(),

		.DO15(), .DO16(), .DO17(), .DO18(), .DO19(), .DO20(), .DO21(),

		.DO22(), .DO23(), .DO24(), .DO25(), .DO26(), .DO27(), .DO28(),

		.DO29(), .DO30(), .DO31(), .DO32(), .DO33(), .DO34(), .DO35(), 

		.EF(Empty_int), .AEF(AlmostEmpty), .AFF(AlmostFull), .FF(Full_int));



    

		

    assign Empty = Empty_int;
    assign Full = Full_int;
endmodule