`timescale 1ns/1ps
`define wrclk_period 40
`define rdclk_period 8

module fifo_test();
	xsGSR xsGSR_INST(.GSR(1'b1));
	xsPWR xsPWR_INST(.PUR(1'b1));

	reg		WrClock;
	reg		WrEn;
	reg		[15:0]Data;
	reg		RdClock;
	reg		RdEn;
	reg		Reset;
	reg		RPReset;

	wire	[7:0]Q;
	wire	Empty;
	wire	Full;
	wire	AlmostEmpty;
	wire	AlmostFull;

	FIFO FIFO(
		.Data(Data),
		.WrClock(WrClock),
		.RdClock(RdClock),
		.WrEn(WrEn), 
		.RdEn(RdEn),  
		.Reset(Reset),
		.RPReset(RPReset), 
		.Q(Q), 
		.Empty(Empty), 
		.Full(Full),
		.AlmostEmpty(AlmostEmpty), 
		.AlmostFull(AlmostFull)
	);
	

	initial WrClock = 1;
	always #(`wrclk_period/2)WrClock = ~WrClock;
	
	initial RdClock = 1;
	always #(`rdclk_period/2)RdClock = ~RdClock;
	
	integer i;
	
	always@(posedge RdClock)
	if(AlmostFull)
		RdEn <= 1;
	else if(Empty)
		RdEn <= 0;

	initial begin
		Reset =1;
		RPReset =0;
		Data = 0;
		WrEn = 0;
		#201;
		Reset =0;
		#200;
		for (i=0;i <= 511 ;i = i + 1)begin
			WrEn = 1;
			Data = i;
			#`wrclk_period;
		end
		WrEn = 0;
		#10000;

		$stop;	
	end

endmodule
